Как сделать "если не истинное условие"?

Я хотел бы иметь echo команда выполняется, когда cat /etc/passwd | grep "sysa" - это неправда.

что я делаю не так?

if ! [ $(cat /etc/passwd | grep "sysa") ]; then
        echo "ERROR - The user sysa could not be looked up"
        exit 2
fi

5 ответов


попробовать

if ! grep -q sysa /etc/passwd ; then

grep возвращает true если он находит цель поиска, и false если это не так.

не так false ==true.

if оценка в оболочках разработана, чтобы быть очень гибкой, и много раз не требует цепочек команд (как вы написали).

кроме того, глядя на ваш код как есть, ваше использование $( ... ) форма cmd-замещения заслуживает похвалы, но подумайте о том, что выходит из процесс. Попробуй!--11--> чтобы увидеть, что я имею в виду. Можно считать, что с помощью -c (count) опция grep, а затем сделать if ! [ $(grep -c "sysa" /etc/passwd) -eq 0 ] ; then который работает, но довольно старая школа.

но вы можете использовать новейшие функции оболочки (арифметическая оценка), такие как

if ! (( $(grep -c "sysa" /etc/passwd) == 0 )) ; then ...`

что также дает вам преимущество использования операторов сравнения на основе c-lang, ==,<,>,>=,<=,% и, возможно, некоторые другие.

в этом случае, согласно комментарию Оруэллофила, арифметика оценка может быть сокращена еще больше, как

if ! (( $(grep -c "sysa" /etc/passwd) )) ; then ....

или

if (( ! $(grep -c "sysa" /etc/passwd) )) ; then ....

наконец, есть награда назвал Useless Use of Cat (UUOC). :- ) Некоторые люди будут прыгать вверх и вниз и плакать gothca! Я просто скажу, что grep может принимать имя файла в своей cmd-строке, поэтому зачем вызывать дополнительные процессы и конструкции каналов, когда вам это не нужно? ;-)

надеюсь, это поможет.


Я думаю, что это можно упростить в:

grep sysa /etc/passwd || {
    echo "ERROR - The user sysa could not be looked up"
    exit 2
}

или в одной командной строке

$ grep sysa /etc/passwd || { echo "ERROR - The user sysa could not be looked up"; exit 2; }


что я делаю не так?

$(...) держит стоимостью, а не статус выхода, поэтому этот подход неправильный. Однако в этом конкретном случае он действительно работает, потому что sysa будет напечатано, что делает тестовый оператор истинным. Однако,if ! [ $(true) ]; then echo false; fi всегда будет печатать false - за true команда ничего не пишет в stdout (даже если код выхода равен 0). Вот почему его нужно перефразировать на if ! grep ...; then.

альтернативой было бы cat /etc/passwd | grep "sysa" || echo error. Edit: как отметил Алекс, кошка здесь бесполезна: grep "sysa" /etc/passwd || echo error.

нашел другие ответы довольно запутанными, надеюсь, это кому-то поможет.


в системах Unix, которые его поддерживают (не macOS кажется):

if getent passwd "$username" >/dev/null; then
    printf 'User %s exists\n' "$username"
else
    printf 'User %s does not exist\n' "$username"
fi 

это имеет то преимущество, что он будет запрашивать любую службу каталогов, которая может использоваться (YP/NIS или LDAP и т. д.) и локальный файл базы данных паролей.


вопрос с grep -q "$username" /etc/passwd это то, что он даст ложное срабатывание, когда нет такого пользователя, но что-то еще соответствует шаблону. Это может произойти, если происходит частичное или точное совпадение где-то еще в файл.

например, в my есть строка

build:*:21:21:base and xenocara build:/var/empty:/bin/ksh

это спровоцирует действительный матч на такие вещи, как cara и enoc etc., хотя в моей системе нет таких пользователей.

на grep решение было правильным, вам нужно будет правильно парсить :

if cut -d ':' -f 1 /etc/passwd | grep -qxF "$username"; then
    # found
else
    # not found
fi

... или любой другой подобный тест против первых :-поля с разделителями.


вот ответ в качестве примера:

для того, чтобы убедиться, что регистраторы данных онлайн cron скрипт запускается каждые 15 минут, который выглядит так:

#!/bin/bash
#
if ! ping -c 1 SOLAR &>/dev/null
then
  echo "SUBJECT:  SOLAR is not responding to ping" | ssmtp abc@def.com
  echo "SOLAR is not responding to ping" | ssmtp 4151112222@txt.att.com
else
  echo "SOLAR is up"
fi
#
if ! ping -c 1 OUTSIDE &>/dev/null
then
  echo "SUBJECT:  OUTSIDE is not responding to ping" | ssmtp abc@def.com
  echo "OUTSIDE is not responding to ping" | ssmtp 4151112222@txt.att.com
else
  echo "OUTSIDE is up"
fi
#

...и так далее для каждого регистратора данных, который вы можете увидеть в монтаже at http://www.SDsolarBlog.com/montage


FYI, используя &>/dev/null перенаправляет все выходные данные команды, включая ошибки, на /dev/null

(условный требуется только exit status на )

также FYI, обратите внимание, что с cron задания выполняются как root нет необходимости использовать sudo ping на cron сценарий.